%module swfdec
%{
/* Includes the header in the wrapper code */
#include "swfdec.h"
%}
 
/* Parse the header file to generate wrappers */
//%include "swfdec.h"

enum {
	SWF_OK = 0,
	SWF_NEEDBITS,
	SWF_WAIT,
	SWF_ERROR,
	SWF_EOF,
	SWF_IMAGE,
	SWF_CHANGE,
};

enum {
	SWF_COLORSPACE_RGB888 = 0,
	SWF_COLORSPACE_RGB565,
};

%include "typemaps.i"
%include "cdata.i"

%newobject SwfdecDecoder_peekImage;
%newobject SwfdecDecoder_getImage;
%apply (char *STRING, int LENGTH) { (char *str, int len) };
%apply int *OUTPUT { int *width, int *height };
%apply double *OUTPUT { double *rate };
typedef struct {
  %extend{
    SwfdecDecoder(){
      return swfdec_decoder_new();
    }
    
    ~SwfdecDecoder(){
      swfdec_decoder_free(self);
    }
    
    int parse(){
      return swfdec_decoder_parse(self);
    }
    
    int setImageSize(int x, int y){
      return swfdec_decoder_set_image_size(self,x,y);
    }
    
    void getImageSize(int *width, int *height){
      swfdec_decoder_get_image_size(self,width,height);
    }
    
    int setColorspace(int cs){
      return swfdec_decoder_set_colorspace(self,cs);
    }
    
    int setDebugLevel(int level){
      return swfdec_decoder_set_debug_level(self,level);
    }
    
    int addBits(char *str, int len){
      return swfdec_decoder_addbits(self,(unsigned char*)str,len);
    }
    
    /*int swfdec_decoder_get_n_frames(SwfdecDecoder *s, int *n_frames);
    void *swfdec_decoder_get_sound_chunk(SwfdecDecoder *s, int *length);*/
    
    void getRate(double *rate){
      swfdec_decoder_get_rate(self, rate);
    }
    
    char *peekImage(){
      int width, height;
      swfdec_decoder_get_image_size(self,&width,&height);
      unsigned char *img;
      swfdec_decoder_peek_image(self,&img);
      return (char*)img;
    }
    
    char *getImage(){
      int width, height;
      swfdec_decoder_get_image_size(self,&width,&height);
      unsigned char *img;
      swfdec_decoder_get_image(self,&img);
      return (char*)img;
    }
  }
} SwfdecDecoder;
